/*
 File: lint_balls.h
 Date and Time: Fri Jan 30 18:55:15 2015 
*/
#ifndef __lint_balls_h__
#define __lint_balls_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "eol.h"
#include "ws.h"
#include "c_comments.h"
  
extern yacco2::Thread_entry ITH_lint_balls;

extern yacco2::State S1_Clint_balls;
namespace NS_lint_balls {
yacco2::THR _YACCO2_CALL_TYPE
TH_lint_balls(yacco2::Parser* Caller);// called thread
yacco2::THR_result _YACCO2_CALL_TYPE
PROC_TH_lint_balls(yacco2::Parser* Caller);// called thread's twin the procedure
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[4];
};
class Clint_balls: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rlint_balls_ = 569//start_of_rule_list + 0
    ,rhs1_Rlint_balls_ = 1
   ,R_Rlint_ = 570//start_of_rule_list + 2
    ,rhs1_Rlint_ = 2
   ,R_Rfluffs_ = 571//start_of_rule_list + 4
    ,rhs1_Rfluffs_ = 3
    ,rhs2_Rfluffs_ = 4
   ,R_Rfluff_ = 572//start_of_rule_list + 6
    ,rhs1_Rfluff_ = 5
    ,rhs2_Rfluff_ = 6
    ,rhs3_Rfluff_ = 7
    ,rhs4_Rfluff_ = 8
  };
  //no of la sets = 2
  //no of states = 11
  Clint_balls();
  ~Clint_balls();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[9];
 };
struct Rlint_balls;
struct Rlint;
struct Rfluffs;
struct Rfluff;
struct Rlint_balls:public yacco2::CAbs_lr1_sym {
  Rlint_balls(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rlint:public yacco2::CAbs_lr1_sym {
  Rlint(yacco2::Parser* P);
  public:
};

struct Rfluffs:public yacco2::CAbs_lr1_sym {
  Rfluffs(yacco2::Parser* P);
  public:
};

struct Rfluff:public yacco2::CAbs_lr1_sym {
  Rfluff(yacco2::Parser* P);
  public:
  void sr2();
  void sr3();
};

} // end of namespace

#endif
